unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Button3: TButton;
    Button4: TButton;
    GroupBox3: TGroupBox;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Button5: TButton;
    GroupBox4: TGroupBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


// Funes de Inicializao
function Bematech_FI_AlteraSimboloMoeda( SimboloMoeda: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ProgramaAliquota( Aliquota: String; ICMS_ISS: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ProgramaHorarioVerao: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NomeiaDepartamento( Indice: Integer; Departamento: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NomeiaTotalizadorNaoSujeitoIcms( Indice: Integer; Totalizador: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ProgramaArredondamento: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ProgramaTruncamento: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LinhasEntreCupons( Linhas: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EspacoEntreLinhas( Dots: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ForcaImpactoAgulhas( ForcaImpacto: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes do Cupom Fiscal
function Bematech_FI_AbreCupom( CGC_CPF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VendeItem( Codigo: String; Descricao: String; Aliquota: String; TipoQuantidade: String; Quantidade: String; CasasDecimais: Integer; ValorUnitario: String; TipoDesconto: String; Desconto: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VendeItemDepartamento( Codigo: String; Descricao: String; Aliquota: String; ValorUnitario: String; Quantidade: String; Acrescimo: String; Desconto: String; IndiceDepartamento: String; UnidadeMedida: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaItemAnterior: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaItemGenerico( NumeroItem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaCupom: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechaCupomResumido( FormaPagamento: String; Mensagem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechaCupom( FormaPagamento: String; AcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String; ValorPago: String; Mensagem: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ResetaImpressora: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_IniciaFechamentoCupom( AcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EfetuaFormaPagamento( FormaPagamento: String; ValorFormaPagamento: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EfetuaFormaPagamentoDescricaoForma( FormaPagamento: string; ValorFormaPagamento: string; DescricaoFormaPagto: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TerminaFechamentoCupom( Mensagem: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EstornoFormasPagamento( FormaOrigem: String; FormaDestino: String; Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UsaUnidadeMedida( UnidadeMedida: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AumentaDescricaoItem( Descricao: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes dos Relatrios Fiscais
function Bematech_FI_LeituraX: Integer; StdCall; External 'BEMAFI32.DLL' ;
function Bematech_FI_ReducaoZ( Data: String; Hora: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RelatorioGerencial( Texto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RelatorioGerencialTEF( Texto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechaRelatorioGerencial: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalData( DataInicial: String; DataFinal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalReducao( ReducaoInicial: String; ReducaoFinal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalSerialData( DataInicial: String; DataFinal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalSerialReducao( ReducaoInicial: String; ReducaoFinal: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes das Operaes No Fiscais
function Bematech_FI_RecebimentoNaoFiscal( IndiceTotalizador: String; Valor: String; FormaPagamento: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AbreComprovanteNaoFiscalVinculado( FormaPagamento: String; Valor: String; NumeroCupom: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UsaComprovanteNaoFiscalVinculado( Texto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UsaComprovanteNaoFiscalVinculadoTEF( Texto: String ): Integer; StdCall; External 'BEMAFI32.DLL'
function Bematech_FI_FechaComprovanteNaoFiscalVinculado: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_Sangria( Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_Suprimento( Valor: String; FormaPagamento: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes de Informaes da Impressora
function Bematech_FI_NumeroSerie( NumeroSerie: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroSerieCriptografado( NumeroSerie: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroSerieDescriptografado( NumeroSerieCriptografado: String; NumeroSerieDescriptografado: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SubTotal( SubTotal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroCupom( NumeroCupom: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraXSerial: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VersaoFirmware( VersaoFirmware: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CGC_IE( CGC: String; IE: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_GrandeTotal( GrandeTotal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_Cancelamentos( ValorCancelamentos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_Descontos( ValorDescontos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroOperacoesNaoFiscais( NumeroOperacoes: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroCuponsCancelados( NumeroCancelamentos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroIntervencoes( NumeroIntervencoes: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroReducoes( NumeroReducoes: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroSubstituicoesProprietario( NumeroSubstituicoes: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UltimoItemVendido( NumeroItem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ClicheProprietario( Cliche: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroCaixa( NumeroCaixa: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroLoja( NumeroLoja: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SimboloMoeda( SimboloMoeda: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MinutosLigada( Minutos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MinutosImprimindo( Minutos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaModoOperacao( Modo: string ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaEpromConectada( Flag: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FlagsFiscais( Var Flag: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ValorPagoUltimoCupom( ValorCupom: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataHoraImpressora( Data: String; Hora: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadoresTotalizadoresNaoFiscais( Contadores: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTotalizadoresNaoFiscais( Totalizadores: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataHoraReducao( Data: String; Hora: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataMovimento( Data: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTruncamento( Flag: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_Acrescimos( ValorAcrescimos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorBilhetePassagem( ContadorPassagem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaAliquotasIss( Flag: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaFormasPagamento( Formas: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaRecebimentoNaoFiscal( Recebimentos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaDepartamentos( Departamentos: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTipoImpressora( Var TipoImpressora: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTotalizadoresParciais( Totalizadores: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RetornoAliquotas( Aliquotas: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaEstadoImpressora( Var ACK: Integer; Var ST1: Integer; Var ST2: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DadosUltimaReducao( DadosReducao: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MonitoramentoPapel( Var Linhas: Integer): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaIndiceAliquotasIss( Flag: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ValorFormaPagamento( FormaPagamento: String; Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ValorTotalizadorNaoFiscal( Totalizador: String; Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TotalIcmsCupom( ValorIcms: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ModeloImpressora( cModeloImp: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes de Autenticao e Gaveta de Dinheiro
function Bematech_FI_Autenticacao:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_Autenticacao';
function Bematech_FI_ProgramaCaracterAutenticacao( Parametros: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AcionaGaveta:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_AcionaGaveta';
function Bematech_FI_VerificaEstadoGaveta( Var EstadoGaveta: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes para a Impressora Restaurante
function Bematech_FIR_AbreCupomRestaurante( Mesa: String; CGC_CPF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_RegistraVenda( Mesa: String; Codigo: String; Descricao: String; Aliquota: String; Quantidade: String; ValorUnitario: String; FlagAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_CancelaVenda( Mesa: String; Codigo: String; Descricao: String; Aliquota: String; Quantidade: String; ValorUnitario: String; FlagAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_ConferenciaMesa( Mesa: String; FlagAcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_AbreConferenciaMesa( Mesa: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_FechaConferenciaMesa( FlagAcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_TransferenciaMesa( MesaOrigem: String; MesaDestino: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_ContaDividida( NumeroCupons: String; ValorPago: String; CGC_CPF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_FechaCupomContaDividida( NumeroCupons: String; FlagAcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String; FormasPagamento: String; ValorFormasPagamento: String; ValorPagoCliente: String; CGC_CPF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_TransferenciaItem( MesaOrigem: String; Codigo: String; Descricao: String; Aliquota: String; Quantidade: String; ValorUnitario: String; FlagAcrescimoDesconto: String; ValorAcrescimoDesconto: String; MesaDestino: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_RelatorioMesasAbertas( TipoRelatorio: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_ImprimeCardapio: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_RelatorioMesasAbertasSerial: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_CardapioPelaSerial: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_RegistroVendaSerial( Mesa: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_VerificaMemoriaLivre( Bytes: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_FechaCupomRestaurante( FormaPagamento: String; FlagAcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String; ValorFormaPagto: String; Mensagem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FIR_FechaCupomResumidoRestaurante( FormaPagamento: String; Mensagem: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funo para a Impressora Bilhete de Passagem
function Bematech_FI_AbreBilhetePassagem( ImprimeValorFinal: string; ImprimeEnfatizado: string; Embarque: string; Destino: string; Linha: string; Prefixo: string; Agente: string; Agencia: string; Data: string; Hora: string; Poltrona: string; Plataforma: string ): Integer; StdCall; External 'BEMAFI32.DLL';

// Outras Funes
function Bematech_FI_AbrePortaSerial: Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RetornoImpressora( Var ACK: Integer; Var ST1: Integer; Var ST2: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechaPortaSerial: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_FechaPortaSerial';
function Bematech_FI_MapaResumo:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_MapaResumo';
function Bematech_FI_AberturaDoDia( ValorCompra: string; FormaPagamento: string ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechamentoDoDia: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_FechamentoDoDia';
function Bematech_FI_ImprimeConfiguracoesImpressora:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_ImprimeConfiguracoesImpressora';
function Bematech_FI_ImprimeDepartamentos: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_ImprimeDepartamentos';
function Bematech_FI_RelatorioTipo60Analitico: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_RelatorioTipo60Analitico';
function Bematech_FI_RelatorioTipo60Mestre: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_RelatorioTipo60Mestre';
function Bematech_FI_VerificaImpressoraLigada: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_VerificaImpressoraLigada';
function Bematech_FI_ImpressaoCarne( Titulo, Percelas, Datas: string; Quantidade: integer; Texto, Cliente, RG_CPF, Cupom: string; Vias, Assina: integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_InfoBalanca( Porta: string; Modelo: integer; Peso, PrecoKilo, Total: string ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DadosSintegra( DataInicio: string; DataFinal: string ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_IniciaModoTEF: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_IniciaModoTEF';
function Bematech_FI_FinalizaModoTEF: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_FinalizaModoTEF';
function Bematech_FI_VersaoDll( Versao: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RegistrosTipo60: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_RegistrosTipo60';
function Bematech_FI_LeArquivoRetorno( Retorno: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_GeraRegistrosCAT52MFD( cArquivo: String; cData: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_GeraRegistrosCAT52MFDEx( cArquivo: String; cData: String; cArqDestino: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional( dataUsuario, dataSoftwareBasico: String; var letraAdicional: char ): integer; stdcall; external 'BEMAFI32.DLL';
function Bematech_FI_VendaBruta ( VendaBruta : String ): integer; stdcall; external 'BEMAFI32.DLL';

// Funes da Impressora Fiscal MFD
function Bematech_FI_AbreCupomMFD(CGC: string; Nome: string; Endereco : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaCupomMFD(CGC, Nome, Endereco: string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ProgramaFormaPagamentoMFD(FormaPagto, OperacaoTef: String) : Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EfetuaFormaPagamentoMFD(FormaPagamento, ValorFormaPagamento, Parcelas, DescricaoFormaPagto: string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CupomAdicionalMFD(): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AcrescimoDescontoItemMFD (Item, AcrescimoDesconto,TipoAcrescimoDesconto, ValorAcrescimoDesconto: string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NomeiaRelatorioGerencialMFD (Indice, Descricao : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AutenticacaoMFD(Linhas, Texto : string) : Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AbreComprovanteNaoFiscalVinculadoMFD(FormaPagamento, Valor, NumeroCupom, CGC, nome, Endereco : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ReimpressaoNaoFiscalVinculadoMFD() : Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AbreRecebimentoNaoFiscalMFD(CGC, Nome, Endereco : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EfetuaRecebimentoNaoFiscalMFD(IndiceTotalizador, ValorRecebimento : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_IniciaFechamentoRecebimentoNaoFiscalMFD(AcrescimoDesconto,TipoAcrescimoDesconto, ValorAcrescimo, ValorDesconto : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FechaRecebimentoNaoFiscalMFD(Mensagem : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaRecebimentoNaoFiscalMFD(CGC, Nome, Endereco : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AbreRelatorioGerencialMFD(Indice : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UsaRelatorioGerencialMFD(Texto : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UsaRelatorioGerencialMFDTEF(Texto : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SegundaViaNaoFiscalVinculadoMFD(): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_EstornoNaoFiscalVinculadoMFD(CGC, Nome, Endereco : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroSerieMFD(NumeroSerie : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VersaoFirmwareMFD(VersaoFirmware : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CNPJMFD(CNPJ : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_InscricaoEstadualMFD(InscricaoEstadual : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_InscricaoMunicipalMFD(InscricaoMunicipal : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TempoOperacionalMFD(TempoOperacional : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MinutosEmitindoDocumentosFiscaisMFD(Minutos : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadoresTotalizadoresNaoFiscaisMFD(Contadores : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTotalizadoresNaoFiscaisMFD(Totalizadores : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaFormasPagamentoMFD(FormasPagamento : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaRecebimentoNaoFiscalMFD(Recebimentos : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaRelatorioGerencialMFD(Relatorios : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorComprovantesCreditoMFD(Comprovantes : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorOperacoesNaoFiscaisCanceladasMFD(OperacoesCanceladas : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorRelatoriosGerenciaisMFD (Relatorios : String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorCupomFiscalMFD(CuponsEmitidos : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ContadorFitaDetalheMFD(ContadorFita : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ComprovantesNaoFiscaisNaoEmitidosMFD(Comprovantes : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_NumeroSerieMemoriaMFD(NumeroSerieMFD : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MarcaModeloTipoImpressoraMFD(Marca, Modelo, Tipo : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ReducoesRestantesMFD(Reducoes : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaTotalizadoresParciaisMFD(Totalizadores : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DadosUltimaReducaoMFD(DadosReducao : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalDataMFD(DataInicial, DataFinal, FlagLeitura : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalReducaoMFD(ReducaoInicial, ReducaoFinal, FlagLeitura : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalSerialDataMFD(DataInicial, DataFinal, FlagLeitura : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraMemoriaFiscalSerialReducaoMFD(ReducaoInicial, ReducaoFinal, FlagLeitura : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_LeituraChequeMFD(CodigoCMC7 : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ImprimeChequeMFD(NumeroBanco, Valor, Favorecido, Cidade, Data, Mensagem, ImpressaoVerso, Linhas : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(FlagRetorno : string): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RetornoImpressoraMFD( Var ACK: Integer; Var ST1: Integer; Var ST2: Integer; Var ST3: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AbreBilhetePassagemMFD(Embarque, Destino, Linha, Agencia, Data, Hora, Poltrona, Plataforma, TipoPassagem, RGCliente, NomeCliente, EnderecoCliente, UFDetino: string ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaAcrescimoDescontoItemMFD( cFlag, cItem: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SubTotalizaCupomMFD: integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SubTotalizaRecebimentoMFD: integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TotalLivreMFD( cMemoriaLivre: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TamanhoTotalMFD( cTamanhoMFD: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AcrescimoDescontoSubtotalRecebimentoMFD( cFlag, cTipo, cValor: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AcrescimoDescontoSubtotalMFD( cFlag, cTipo, cValor: string): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaAcrescimoDescontoSubtotalMFD( cFlag: string): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaAcrescimoDescontoSubtotalRecebimentoMFD( cFlag: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TotalizaCupomMFD: integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TotalizaRecebimentoMFD: integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_PercentualLivreMFD( cMemoriaLivre: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataHoraUltimoDocumentoMFD( cDataHora: string ): integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_MapaResumoMFD:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_MapaResumoMFD';
function Bematech_FI_RelatorioTipo60AnaliticoMFD: Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_RelatorioTipo60AnaliticoMFD';
function Bematech_FI_ValorFormaPagamentoMFD( FormaPagamento: String; Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ValorTotalizadorNaoFiscalMFD( Totalizador: String; Valor: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaEstadoImpressoraMFD( Var ACK: Integer; Var ST1: Integer; Var ST2: Integer; Var ST3: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_IniciaFechamentoCupomMFD( AcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimo: String; ValorDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TerminaFechamentoCupomCodigoBarrasMFD( cMensagem: String; cTipoCodigo: String; cCodigo: String; iAltura: Integer; iLargura: Integer; iPosicaoCaracteres: Integer; iFonte: Integer; iMargem: Integer; iCorrecaoErros: Integer; iColunas: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaItemNaoFiscalMFD( NumeroItem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AcrescimoItemNaoFiscalMFD( NumeroItem: String; AcrescimoDesconto: String; TipoAcrescimoDesconto: String; ValorAcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CancelaAcrescimoNaoFiscalMFD( NumeroItem: String; AcrescimoDesconto: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_ImprimeClicheMFD:Integer; StdCall; External 'BEMAFI32.DLL' Name 'Bematech_FI_ImprimeClicheMFD';
function Bematech_FI_ImprimeInformacaoChequeMFD( Posicao: Integer; Linhas: Integer; Mensagem: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_RelatorioSintegraMFD( iRelatorios: Integer; cArquivo: String; cMes: String; cAno: String; cRazaoSocial: String; cEndereco: String; cNumero: String; cComplemento: String; cBairro: String; cCidade: String; cCEP: String; cTelefone: String; cFax: String; cContato: String): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_GeraRelatorioSintegraMFD( iRelatorios : Integer; cArquivoOrigem : String; cArquivoDestino: String; cMes: String; cAno: String; cRazaoSocial: String; cEndereco: String; cNumero: String; cComplemento: String; cBairro: String; cCidade: String; cCEP: String; cTelefone: String; cFax: String; cContato: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DownloadMF( Arquivo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DownloadMFD( Arquivo: String; TipoDownload: String; ParametroInicial: String; ParametroFinal: String; UsuarioECF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_FormatoDadosMFD( ArquivoOrigem: String; ArquivoDestino: String; TipoFormato: String; TipoDownload: String; ParametroInicial: String; ParametroFinal: String; UsuarioECF: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes disponveis somente na impressora fiscal MP-2000 TH FI verso 01.01.01 ou 01.00.02
function Bematech_FI_AtivaDesativaVendaUmaLinhaMFD( iFlag: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AtivaDesativaAlinhamentoEsquerdaMFD( iFlag: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AtivaDesativaCorteProximoMFD(): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_AtivaDesativaTratamentoONOFFLineMFD( iFlag: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_StatusEstendidoMFD( Var iStatus: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_VerificaFlagCorteMFD( Var iStatus: Integer ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_TempoRestanteComprovanteMFD( cTempo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_UFProprietarioMFD( cUF: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_GrandeTotalUltimaReducaoMFD( cGT: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_DataMovimentoUltimaReducaoMFD( cData: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_SubTotalComprovanteNaoFiscalMFD( cSubTotal: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_InicioFimCOOsMFD( cCOOIni, cCOOFim: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_InicioFimGTsMFD( cGTIni, cGTFim: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funo para Configurao dos Cdigos de Barras
function Bematech_FI_ConfiguraCodigoBarrasMFD( Altura: Integer; Largura: Integer; PosicaoCaracteres: Integer; Fonte: Integer; Margem: Integer): Integer; StdCall; External 'BEMAFI32.DLL';

// Funes para Impresso dos Cdigos de Barras
function Bematech_FI_CodigoBarrasUPCAMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasUPCEMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasEAN13MFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasEAN8MFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasCODE39MFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasCODE93MFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasCODE128MFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasITFMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasCODABARMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasISBNMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasMSIMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasPLESSEYMFD( Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';
function Bematech_FI_CodigoBarrasPDF417MFD( NivelCorrecaoErros: Integer; Altura: Integer; Largura: Integer; Colunas: Integer; Codigo: String ): Integer; StdCall; External 'BEMAFI32.DLL';

// Funo para gerar o relatrio Tipo E
function BemaGeraRegistrosTipoE( cArqMFD: string; cArqTXT: string; cDataInicial: string; cDataFinal: string; cRazao: string; cEndereco: string; cPAR1: string; cCMD: string; cPAR2: string; cPAR3: string; cPAR4: string; cPAR5: string; cPAR6: string; cPAR7: string; cPAR8: string; cPAR9: string; cPAR10: string; cPAR11: string; cPAR12: string; cPAR13: string; cPAR14: string ): Integer; StdCall; External 'BemaMFD2.dll';  

implementation


{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject); //Boto para LeituraX
Var
  iRetorno: Integer;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;
  cModeloImp: String;



begin
  cFlag := '1';
  SetLength (cModeloImp, 10);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  If (RadioButton2.Checked = True) then //Condio para o tipo de LeituraX
  begin
    iRetorno := Bematech_FI_LeituraX(); //LeituraX impressa
    if (iRetorno = 1) then //Validao de erro no comando da leituraX
    begin
      If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      end
      Else
      begin
        iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
      end;
    end
    Else
    begin
      application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
    end;
  end
  Else
  begin
    iRetorno := Bematech_FI_LeituraXSerial(); //LeituraX por aqruivo
    if (iRetorno = 1) then
    begin
      If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      end
      Else
      begin
        iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
      end;
    end
    Else
    begin
      application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);  //Boto para a Leitura da Memria Fiscal Completa (LMFC)
Var
iRetorno: Integer;
cModeloImp: String;
cTipo: String;
iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;

begin
  cFlag := '1';
  SetLength(cModeloImp,10);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp); //Comando para verificar o modelo de impressora usada
  if (iRetorno = 0)then
  begin
    application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
  end
  Else
  begin
  If (RadioButton2.Checked = True) then //Condio para Leitura impressa ou em arquivo
  begin
    if (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') then //Esta condio serve para diferenciar se o comando
    begin                                                                  //usado ser com final MFD ou no
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        iRetorno := Bematech_FI_LeituraMemoriaFiscalData(Edit1.Text, Edit2.Text);  //Leitura da MF por data
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        iRetorno := Bematech_FI_LeituraMemoriaFiscalReducao(Edit1.Text, Edit2.Text);  //Leitura da MF por reduo
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end
    Else
    begin
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        cTipo := 'c'; //Varivel para o tipo de leitura (c-completa; s-simplificada)
        iRetorno := Bematech_FI_LeituraMemoriaFiscalDataMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por data completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        cTipo := 'c'; //Varivel para o tipo de leitura (c-completa; s-simplificada)
        iRetorno := Bematech_FI_LeituraMemoriaFiscalReducaoMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por reduo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end;
  end
  Else
  begin
    if (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') then //Esta condio serve para diferenciar se o comando
    begin                                                                  //usado ser com final MFD ou no
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialData(Edit1.Text, Edit2.Text);  //Leitura da MF por data em arquivo
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialReducao(Edit1.Text, Edit2.Text); //Leitura da MF por reduo em arquivo
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end
    Else
    begin
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        cTipo := 'c';
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialDataMFD(Edit1.Text, Edit2.Text, pchar(cTipo));  //Leitura da MF por data em arquivo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        cTipo := 'c';
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialReducaoMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por reduo em arquivo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end;
  end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject); //Bonto para a Leitura da Memria Fiscal Simplificada (LMFS)
Var
iRetorno: Integer;
cModeloImp: String;
cTipo: String;
iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;

begin
  cFlag := '1';
  SetLength(cModeloImp,10);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp); //Comando para verificar o modelo de impressora usada
  if (iRetorno = 0)then
  begin
    application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
  end
  Else
  begin
  If (RadioButton2.Checked = True) then //Condio para Leitura impressa ou em arquivo
  begin
    if (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') then //Esta condio serve para diferenciar o modelo da impressora
    begin                                                                  //Os modelos MP20 e MP40 no tem leitura da MF simplificada
      application.MessageBox('Este modelo de impressora no suporta esta operao!','ALERTA',MB_ICONINFORMATION + MB_OK );
    end
    Else
    begin
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        cTipo := 's'; //Varivel para o tipo de leitura (c-completa; s-simplificada)
        iRetorno := Bematech_FI_LeituraMemoriaFiscalDataMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por data completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        cTipo := 's'; //Varivel para o tipo de leitura (c-completa; s-simplificada)
        iRetorno := Bematech_FI_LeituraMemoriaFiscalReducaoMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por reduo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end;
  end
  Else
  begin
    if (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') then //Esta condio serve para diferenciar o modelo da impressora
    begin                                                                  //Os modelos MP20 e MP40 no tem leitura da MF simplificada
      application.MessageBox('Este modelo de impressora no suporta esta operao!','ALERTA',MB_ICONINFORMATION + MB_OK );
    end
    Else
    begin
      if (RadioButton3.Checked = True) then  //Esta condio verifica o tipo de intervalo (reduo ou data)
      begin
        cTipo := 's';
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialDataMFD(Edit1.Text, Edit2.Text, pchar(cTipo));  //Leitura da MF por data em arquivo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      else
      begin
        cTipo := 's';
        iRetorno := Bematech_FI_LeituraMemoriaFiscalSerialReducaoMFD(Edit1.Text, Edit2.Text, pchar(cTipo)); //Leitura da MF por reduo em arquivo completa
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end;
  end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);  //Boto para gerar o Espelho da MFD
Var
  iRetorno: Integer;
  cModeloImp: String;
  cTipoIntervalo: String;
  cUsuario: String;
  cDownload: String;
  cArquivo: String;
  cFormato: String;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;

begin
  cFlag := '1';
  SetLength(cModeloImp,10);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp); //Comando para retornar o modelo da impressora
  if (iRetorno = 0) then
  begin
    application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
  end
  Else
  begin
    If(Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') or (Trim(cModeloImp) = 'MP25FI') or (Trim(cModeloImp) = 'MP50FI') then //Verifica se  uma impressora com MFD
    begin
      application.MessageBox('Este modelo de impressora no da suporte a este comando!','ERRO',MB_ICONINFORMATION + MB_OK );
    end
    Else
    begin
      if (RadioButton5.Checked = True) then   //Condio para verificar se  por intervalo de data ou COO
      begin
        cTipoIntervalo := '1';      //Intervalo por Data
        cUsuario := '1';
        cDownload := 'Download.mfd';
        cArquivo := 'C:\EspelhodaMFD-PAF.txt';
        cFormato := '0';   //Gerando arquivo em TXT
        iRetorno := Bematech_FI_DownloadMFD(cDownload, cTipoIntervalo, Edit3.Text, Edit4.Text, cUsuario); //Fazendo o download da MFD da impressora
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
          iRetorno := Bematech_FI_FormatoDadosMFD(cDownload, cArquivo, cFormato, cTipoIntervalo, Edit3.Text, Edit4.Text, cUsuario);  //Convertendo o arquivo .MFD para .TXT
          if (iRetorno = 1) then
          begin
            iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
            iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
          end
          Else
          begin
            application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
          end;
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end
      Else
      begin
        cTipoIntervalo := '2';   //Intervalo por COO
        cUsuario := '1';
        cDownload := 'Download.mfd';
        cArquivo := 'C:\EspelhodaMFD-PAF.txt';
        cFormato := '0';
        iRetorno := Bematech_FI_DownloadMFD(cDownload, cTipoIntervalo, Edit3.Text, Edit4.Text, cUsuario);  //Fazendo o download da MFD da impressora
        if (iRetorno = 1) then
        begin
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
          iRetorno := Bematech_FI_FormatoDadosMFD(cDownload, cArquivo, cFormato, cTipoIntervalo, Edit3.Text, Edit4.Text, cUsuario);  //Convertendo o arquivo .MFD pra .TXT
          if (iRetorno = 1) then
          begin
            iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
            iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
          end
          Else
          begin
            application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
          end;
        end
        Else
        begin
          application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject); //Boto para gerar o ArquivoMFD
Var
  iRetorno: Integer;
  cModeloImp: String;
  cTipo: String;
  cTipoDow: String;
  cRazao: String;
  cDownload: String;
  cArquivo: String;
  cEndereco: String;
  cUsuario: String;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;

begin
  cFlag := '1';
  SetLength(cModeloImp, 10);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp); //Comando para retornar o modelo da impressora
  If (iRetorno = 0) then
  begin
    application.MessageBox('Erro de comunicao!','ERRO',MB_ICONINFORMATION + MB_OK );
  end
  Else
  begin
    If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI') or (Trim(cModeloImp) = 'MP25FI') or (Trim(cModeloImp) = 'MP50FI')then  //Verifica se  uma impressora com MFD
    begin
      application.MessageBox('Este modelo de impressora no da suporte a este comando!','ERRO',MB_ICONINFORMATION + MB_OK );
    end
    Else
    begin
      cDownload := 'Download.mfd';
      cArquivo := 'C:\ArquivoMFD-PAF.txt';
      cRazao := 'Bematech';
      cEndereco := 'Rua Joo Gualberto, 1259';
      cTipo := '2';
      cTipoDow := '1';
      cUsuario := '1';
      If (RadioButton5.Checked = True) then //Condio para verificar se  por intervalo de data ou COO
      begin
        iRetorno := Bematech_FI_DownloadMFD(cDownload, cTipoDow, Edit3.Text, Edit4.Text, cUsuario);  //Fazendo o download da MFD da imprssora
        If (iRetorno = 0) then
        begin
          application.MessageBox('Erro de execuo do comando!','ERRO',MB_ICONINFORMATION + MB_OK );
        end
        Else
        begin        //Gerando o arquivo TXT do AtoCotepe 17/04
          iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
          iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
          iRetorno := BemaGeraRegistrosTipoE(cDownload, cArquivo, Edit3.Text, Edit4.Text, cRazao, cEndereco, '', cTipo, '', '', '', '', '', '', '', '', '', '', '', '', '');
        end;
      end
      Else    //As impressoras da Bematech no geram o TXT do AtoCotepe 17/04 por intervalo de COO
      begin
        application.MessageBox('Impressoras no suportam este comando gerando por COO!','ERRO',MB_ICONINFORMATION + MB_OK );
      end;
    end;
  end;
end;

//As infromaes para os relatrios do Anexo VI podero ser buscadas da impressora de acordo com
//este exemplo. Porem vrias destas informaes no podero ser buscadas posterior ao movimento atual da impressora.
//Desta maneira indicamos que armazenem os dados em banco de dados para a gerao dos relatrios em uma data futura.


procedure TForm1.Button6Click(Sender: TObject);  //Boto para recuperar as informaes do R01
Var
  iRetorno: Integer;
  cBuffer: String;
  cNumSerie: String;
  cDHUsuario: String;
  cSWBasico: String;
  cMFAd: Char;
  cModeloImp: String;
  cVerFirmware: String;
  cNumCaixa: String;
  cMarca: String;
  cTipo: String;
  cModeloMFD: String;
  cCGC: String;
  cIE: String;
  cData: String;
  cHora: String;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;

begin
  cFlag := '1';
  SetLength(cModeloImp, 10);
  Memo1.Lines.Add('Campo01: R01');
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);  //Comando para verificar o modelo da impressora
  If(iRetorno = 1) then
  begin
    If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then //Caso seja MP20FI ou MP40FI executar as funes especficas
    begin
      SetLength(cNumSerie,15);
      SetLength(cNumCaixa,4);
      SetLength(cCGC,18);
      SetLength(cIE,15);
      SetLength(cVerFirmware,4);
      iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo02: ' + cNumSerie);
      end;
      Memo1.Lines.Add('Campo03: "Este modelo no retorna esta informao."');
      Memo1.Lines.Add('Campo04: ECF-IF');
      Memo1.Lines.Add('Campo05: Bematech');
      Memo1.Lines.Add('Campo06: ' + cModeloImp);
      iRetorno := Bematech_FI_VersaoFirmware(cVerFirmware);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo07: ' + cVerFirmware);
      end;
      Memo1.Lines.Add('Campo08: Este modelo no possui esta informao');
      Memo1.Lines.Add('Campo09: Este modelo no possui esta informao');
      iRetorno := Bematech_FI_NumeroCaixa(cNumCaixa);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo10: ' + cNumCaixa);
      end;
      iRetorno := Bematech_FI_CGC_IE(cCGC, cIE);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo11: ' + cCGC);
        Memo1.Lines.Add('Campo12: ' + cIE);
      end;
      //As infromaes abaixo no so retornadas pela impressora e devero ser controladas pelo aplicativo.
      Memo1.Lines.Add('Campo13: "CNPJ Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo14: "IE Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo15: "IM Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo16: "Denominao Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo17: "Nome Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo18: "Verso Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo19: "MD5", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo20: "Data incial Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo21: "Data Final Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo22: "Especificao Desenvolvedor", Informao tratada pela aplicao');
    end
    Else //Caso no seja MP20FI e MP40FI ir executar os procedimentos abaixo
    begin
      SetLength(cNumSerie, 20);
      SetLength(cDHUsuario,20);
      SetLength(cSWBasico,20);
      SetLength(cMarca,15);
      SetLength(cModeloMFD,20);
      SetLength(cTipo,7);
      SetLength(cVerFirmware,4);
      SetLength(cNumCaixa,4);
      SetLength(cCGC,20);
      SetLength(cIE,20);
      cMFAd := ' ';
      iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
      iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
      If (iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo02: ' + cNumSerie);
      end;
      iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDHUsuario,cSWBasico,cMFAd);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo03: ' + cMFAd);
      end;
      iRetorno := Bematech_FI_MarcaModeloTipoImpressoraMFD(cMarca,cModeloMFD,cTipo);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo04: ' + cTipo);
        Memo1.Lines.Add('Campo05: ' + cMarca);
        Memo1.Lines.Add('Campo06: ' + cModeloMFD);
      end;
      iRetorno := Bematech_FI_VersaoFirmware(cVerFirmware);
      If (iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo07: ' + cVerFirmware);
      end;
      cData := Copy(cSWBasico,1,2) + Copy(cSWBasico,4,2) + Copy(cSWBasico,7,4);
      Memo1.Lines.Add('Campo08: '+ cData);
      cHora := Copy(cSWBasico,12,2) + Copy(cSWBasico,15,2) + Copy(cSWBasico,18,2);
      Memo1.Lines.Add('Campo09:'+ cHora);
      iRetorno := Bematech_FI_NumeroCaixa(cNumCaixa);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo10: ' + cNumCaixa);
      end;
      iRetorno := Bematech_FI_CNPJMFD(cCGC);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo11: ' + cCGC);
      end;
      iRetorno := Bematech_FI_InscricaoEstadualMFD(cIE);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo12: ' + cIE);
      end;
      Memo1.Lines.Add('Campo13: "CNPJ Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo14: "IE Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo15: "IM Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo16: "Denominao Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo17: "Nome Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo18: "Verso Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo19: "MD5", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo20: "Data incial Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo21: "Data Final Desenvolvedor", Informao tratada pela aplicao');
      Memo1.Lines.Add('Campo22: "Especificao Desenvolvedor", Informao tratada pela aplicao');
    end;
  end
  Else
  begin
    application.MessageBox('Erro no Comando de Numero de Serie!','ERRO',MB_ICONINFORMATION + MB_OK );
  end;

end;

procedure TForm1.Button7Click(Sender: TObject); //Boto para recuperar as informaes do R02
var
  iRetorno: Integer;
  cUsuario: String;
  cNumSerie: String;
  cDHUsuario: String;
  cSWBasico: String;
  cMFAd: Char;
  cModeloImp: String;
  cVerFirmware: String;
  cNumCaixa: String;
  cCGC: String;
  cIE: String;
  cData: String;
  cHora: String;
  cDadosReducao: String;
  cCOORZ: String;
  cCRZ: String;
  cCRO: String;
  cDataMovimento: String;
  cDataReducao: String;
  cHorareducao: String;
  cVendaBruta: String;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  cFlag: String;
begin
  SetLength(cModeloImp,10);
  cMFAd := ' ';
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  Memo1.Lines.Add('Campo01: R02');
  If(iRetorno = 1)then
  begin
    If(Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then //Caso seja MP20FI ou MP40FI executar as funes especficas
    begin
      SetLength(cNumSerie,15);
      SetLength(cDHUsuario,20);
      SetLength(cSWBasico,20);
      SetLength(cUsuario,4);
      SetLength(cDadosReducao,631);
      SetLength(cVendaBruta,18);
      iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
      if(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo02: ' + cNumSerie);
      end;
      Memo1.Lines.Add('Campo03: "Este modelo no retorna esta informao."');
      Memo1.Lines.Add('Campo04: ' + cModeloImp);
      iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo05: ' + cUsuario);
      end;
      iRetorno := Bematech_FI_DadosUltimaReducao(cDadosReducao);
      if(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        cCOORZ := Copy(cDadosReducao,569,6);
        Memo1.Lines.Add('Campo07: ' + cDadosReducao);
      end;
      cDataMovimento := Copy(cDadosReducao,583,6);
      Memo1.Lines.Add('Campo09: ' + cDataMovimento);
      iRetorno := Bematech_FI_DataHoraReducao(cDataReducao,cHorareducao);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo10: ' + cDataReducao);
        Memo1.Lines.Add('Campo11: ' + cHorareducao);
      end;
      iRetorno := Bematech_FI_VendaBruta(cVendaBruta);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
        Memo1.Lines.Add('Campo12: ' + cVendaBruta);
      end;
      Memo1.Lines.Add('Campo13: Este modelo de impressora no trabalha com ISS');
    end
    Else
    begin
      cFlag := '1';
      SetLength(cNumSerie,20);
      SetLength(cUsuario,4);
      SetLength(cDadosReducao,1278);
      SetLength(cDataReducao,6);
      SetLength(cHorareducao,6);
      SetLength(cVendaBruta,18);
      SetLength(cDHUsuario,20);
      SetLength(cSWBasico,20);
      iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
      iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo02: ' + cNumSerie);
      end;
      iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDHUsuario,cSWBasico,cMFAd);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo03: ' + cMFAd);
      end;
      Memo1.Lines.Add('Campo04: ' + cModeloImp);
      iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo05: ' + cUsuario);
      end;
      iRetorno := Bematech_FI_DadosUltimaReducaoMFD(cDadosReducao);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        cCRZ := Copy(cDadosReducao,9,4);
        Memo1.Lines.Add('Campo06: ' + cCRZ);
        cCOORZ := Copy(cDadosReducao,14,6);
        Memo1.Lines.Add('Campo07: ' + cCOORZ);
        cCRO := Copy(cDadosReducao,4,4);
        Memo1.Lines.Add('Campo08: ' + cCRO);
        cDataMovimento := Copy(cDadosReducao,1273,6);
        Memo1.Lines.Add('Campo09: ' + cDataMovimento);
      end;
      iRetorno := Bematech_FI_DataHoraReducao(cDataReducao,cHorareducao);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo10: ' + cDataReducao);
        Memo1.Lines.Add('Campo11: ' + cHorareducao);
      end;
      iRetorno := Bematech_FI_VendaBruta(cVendaBruta);
      If(iRetorno = 1)then
      begin
        iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
        Memo1.Lines.Add('Campo12: ' + cVendaBruta);
      end;
      Memo1.Lines.Add('Campo13: As impressoras no retornam esta informao.');
    end;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject); //Comando para gerao do relatrio R03
var
  cModeloImp: String;
  cNumSerie: String;
  cUsuario: String;
  cDHUsuario: String;
  cSWBasico: String;
  cDadosReducao: String;
  cCRZ: String;
  cMFAd: Char;
  cAliquota: String;
  cTotalizador: String;
  cRetornotxt: TextFile;
  cLinhatxt: String;
  iRetorno: Integer;
  iACK: Integer;
  iST1: Integer;
  iST2: Integer;
  iST3: Integer;
  iRelatorio: Integer;
  iIndex: Integer;
  iInTotalizador: Integer;
  cBuffer: String;
  iTotal: Integer;

  iConta: integer;
begin
  SetLength(cModeloImp,10);
  SetLength(cUsuario,4);
  SetLength(cDadosReducao,631);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
  If(Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
  begin
    SetLength(cNumSerie,15);
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);

    end;

    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);

    end;
    iRetorno := Bematech_FI_MapaResumo();
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      AssignFile(cRetornotxt, 'c:\Retorno.txt');
      Reset(cRetornotxt);
      Readln(cRetornotxt,cLinhatxt);

    end;
    iRetorno := Bematech_FI_DadosUltimaReducao(cDadosReducao);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      iRelatorio := 0;
      iIndex := 53;
      iConta := 0;
      iInTotalizador := 118;
      iTotal := 0;
      While (iRelatorio = 0)do
      begin
        cAliquota := Copy(cDadosReducao,iIndex,4);
        If(cAliquota <> '0000')then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + '     ';
          cBuffer := cBuffer + ' ';
          cBuffer := cBuffer + cModeloImp + '              ';
          cBuffer := cBuffer + cUsuario;
          cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
          cBuffer := cBuffer + FormatFloat('00',iConta +1) + 'T' + cAliquota;
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 14;
          iIndex := iIndex + 4;
        end
        Else
        begin
          iInTotalizador := 342;
          If(iInTotalizador = 342)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'I1';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := iInTotalizador + 14;
            iRelatorio := 1;
          end;
          If(iInTotalizador = 356)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'F1';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := iInTotalizador + 14;
          end;
          If(iInTotalizador = 370)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'N1';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := 38;
          end;
          If(iInTotalizador = 38)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'DT';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := 603;
          end;
          If(iInTotalizador = 603)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'AT';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := 23;
          end;
          If(iInTotalizador = 23)then
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'Can-T';
            cBuffer := cBuffer + cTotalizador;
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := 385;
          end;
          If(iInTotalizador = 385)then
          begin
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,385,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,400,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,415,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,428,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,442,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,456,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,470,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,484,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,498,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,512,14));
            iTotal := iTotal + StrToInt(Copy(cDadosReducao,526,14));
            cBuffer := 'R03';
            cBuffer := cBuffer + cNumSerie;
            cBuffer := cBuffer + '     ';
            cBuffer := cBuffer + ' ';
            cBuffer := cBuffer + cModeloImp + '              ';
            cBuffer := cBuffer + cUsuario;
            cBuffer := cBuffer + '00' + Copy(cLinhatxt,37,4);
            cBuffer := cBuffer + 'F1';
            cBuffer := cBuffer + FormatFloat('00000000000000',iTotal);
            Memo1.Lines.Add(cBuffer);
            iInTotalizador := iInTotalizador + 14;
          end;
        end;

      end;
      

    end;

  end
  Else
  begin
    SetLength(cNumSerie,20);
    SetLength(cUsuario,4);
    SetLength(cDHUsuario,20);
    SetLength(cSWBasico,20);
    SetLength(cDadosReducao,1278);
    cMFAd := ' ';

    iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);

    end;
    iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDHUsuario,cSWBasico,cMFAd);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);

    end;
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);

    end;
    iRetorno := Bematech_FI_DadosUltimaReducaoMFD(cDadosReducao);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iST1,iST2,iST3);
      cCRZ := Copy(cDadosReducao,9,4);

    end;
    iRelatorio := 0;
    iIndex := 1208;
    iInTotalizador := 335;
    iConta := 0;
    iTotal := 0;
    While (iRelatorio = 0)do
    begin
      cAliquota := Copy(cDadosReducao,iIndex,4);
      If(cAliquota <> '0000')then
      begin
        cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
        cBuffer := 'R03';
        cBuffer := cBuffer + cNumSerie;
        cBuffer := cBuffer + cMFAd;
        cBuffer := cBuffer + Trim(cModeloImp) + '            ';
        cBuffer := cBuffer + Copy(cUsuario,3,2);
        cBuffer := cBuffer + '00';
        cBuffer := cBuffer + cCRZ;
        cBuffer := cBuffer + formatfloat('00',iConta+1) + 'T' + cAliquota;
        cBuffer := cBuffer + cTotalizador;
        Memo1.Lines.Add(cBuffer);
        iInTotalizador := iInTotalizador + 14;
      end
      Else
      begin
        iInTotalizador := 560;
        If(iInTotalizador = 560)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'I1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
          iRelatorio := 1;
        end;
        If(iInTotalizador = 575)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'N1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 590)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'F1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 605)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'IS1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 620)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'NS1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 635)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'FS1';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 650)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'DT';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 665)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'DS';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 680)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'AT';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 695)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'AS';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 710)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'Can-T';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 725)then
        begin
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'Can-S';
          cBuffer := cBuffer + cTotalizador;
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
        If(iInTotalizador = 740)then
        begin
          While (iInTotalizador < 1132)do
          begin
            cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
            iTotal := iTotal + StrToInt(cTotalizador);
            iInTotalizador := iInTotalizador + 14;
          end;
          iInTotalizador := iInTotalizador + 1;
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          iTotal := iTotal + StrToInt(cTotalizador);
          iInTotalizador := iInTotalizador + 15;
          cTotalizador := Copy(cDadosReducao,iInTotalizador,14);
          iTotal := iTotal + StrToInt(cTotalizador);
          cBuffer := 'R03';
          cBuffer := cBuffer + cNumSerie;
          cBuffer := cBuffer + cMFAd;
          cBuffer := cBuffer + Trim(cModeloImp) + '            ';
          cBuffer := cBuffer + Copy(cUsuario,3,2);
          cBuffer := cBuffer + '00';
          cBuffer := cBuffer + cCRZ;
          cBuffer := cBuffer + 'OPNF';
          cBuffer := cBuffer + FormatFloat('0000000000000',iTotal);
          Memo1.Lines.Add(cBuffer);
          iInTotalizador := iInTotalizador + 15;
        end;
      end;
      iConta := iConta + 1;
      iIndex := iIndex + 4;

    end;
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  cNumSerie: String;
  cModeloImp: String;
  cUsuario: String;
  cCOO: String;
  cData: String;
  cHora: String;
  cSubTotal: String;
  cCCF: String;
  cDTUsuario: String;
  cSWBasico: String;
  cMFAdicional: Char;
  cFlag: String;
  iRetorno: Integer;
  iACK: Integer;
  iSt1: Integer;
  iSt2: Integer;
  iSt3: Integer;

begin
  SetLength(cModeloImp,10);
  SetLength(cUsuario,4);
  SetLength(cCOO,6);
  SetLength(cData,6);
  SetLength(cHora,6);
  SetLength(cSubTotal,14);
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
  If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
  begin
    SetLength(cNumSerie,15);
    Memo1.Lines.Add('Campo01: R04');
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    Memo1.Lines.Add('Campo03: No retornado pelo modelo de impressora');
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    Memo1.Lines.Add('Campo06: Informao no retornada pelo modelo de impressora');
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo07: ' + cCOO);
    end;
    iRetorno := Bematech_FI_DataHoraImpressora(cData,cHora); //Este comando dever ser enviado logo aps a abertura do cupom.
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo08: ' + cData);
    end;
    iRetorno := Bematech_FI_SubTotal(cSubTotal);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);//Este comando deve ser usado antes de utilizar as formas de pagamento.
      Memo1.Lines.Add('Campo09: ' + cSubTotal);
    end;
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Para esta informao voc pode utilizar o comando Bematech_FI_Descontos porem esta informao ter que ser tratada.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    Memo1.Lines.Add('Campo12: Esta Informao dever ser controlada pelo aplicativo.');
    //Para esta informao voc pode utilizar o comando Bematech_FI_Acrescimos porem esta informao ter que ser tratada.
    Memo1.Lines.Add('Campo13: Esta Informao dever ser controlada pelo aplicativo.');
    Memo1.Lines.Add('Campo14: Esta Informao dever ser controlada pelo aplicativo.');
    //Para o Valor Lquido do Cupom o aplicativo ter que tratar a informao em conjuto do valor do subtotal com os descontos e acrescimos.
    Memo1.Lines.Add('Campo15: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar o cancelamento.
    Memo1.Lines.Add('Campo16: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar o cancelamento de acrescimo.
    Memo1.Lines.Add('Campo17: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar a ordom do acrescimo ou desconto.
    Memo1.Lines.Add('Campo18: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a informao do consumidor.
    Memo1.Lines.Add('Campo19: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a informao do consumidor.
  end
  Else
  begin
    SetLength(cNumSerie,20);
    SetLength(cCCF,6);
    SetLength(cDTUsuario,20);
    SetLength(cSWBasico,20);
    cMFAdicional := ' ';
    cFlag := '1';
    iRetorno := Bematech_FI_HabilitaDesabilitaRetornoEstendidoMFD(cFlag);
    Memo1.Lines.Add('Campo01: R04');
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDTUsuario,cSWBasico,cMFAdicional);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo03: ' + cMFAdicional);
    end;
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_ContadorCupomFiscalMFD(cCCF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo06: ' + cCCF);
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo07: ' + cCOO);
    end;
    iRetorno := Bematech_FI_DataHoraImpressora(cData,cHora); //Este comando dever ser enviado logo aps a abertura do cupom.
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo08: ' + cData);
    end;
    iRetorno := Bematech_FI_SubTotal(cSubTotal);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);//Este comando deve ser usado antes de utilizar as formas de pagamento.
      Memo1.Lines.Add('Campo09: ' + cSubTotal);
    end;
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Para esta informao voc pode utilizar o comando Bematech_FI_Descontos porem esta informao ter que ser tratada.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    Memo1.Lines.Add('Campo12: Esta Informao dever ser controlada pelo aplicativo.');
    //Para esta informao voc pode utilizar o comando Bematech_FI_Acrescimos porem esta informao ter que ser tratada.
    Memo1.Lines.Add('Campo13: Esta Informao dever ser controlada pelo aplicativo.');
    Memo1.Lines.Add('Campo14: Esta Informao dever ser controlada pelo aplicativo.');
    //Para o Valor Lquido do Cupom o aplicativo ter que tratar a informao em conjuto do valor do subtotal com os descontos e acrescimos.
    Memo1.Lines.Add('Campo15: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar o cancelamento.
    Memo1.Lines.Add('Campo16: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar o cancelamento de acrescimo.
    Memo1.Lines.Add('Campo17: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que controlar a ordom do acrescimo ou desconto.
    Memo1.Lines.Add('Campo18: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a informao do consumidor.
    Memo1.Lines.Add('Campo19: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a informao do consumidor.
  end;

end;

procedure TForm1.Button10Click(Sender: TObject);
var
  cNumSerie: String;
  cModeloImp: String;
  cUsuario: String;
  cCOO: String;
  cData: String;
  cHora: String;
  cSubTotal: String;
  cCCF: String;
  cDTUsuario: String;
  cSWBasico: String;
  cMFAdicional: Char;
  cFlag: String;
  cNumItem: String;
  cTruncamento: string;
  iRetorno: Integer;
  iACK: Integer;
  iSt1: Integer;
  iSt2: Integer;
  iSt3: Integer;
  iConta: integer;
begin
  SetLength(cModeloImp,10);
  SetLength(cUsuario,4);
  SetLength(cCOO,6);
  SetLength(cCCF,6);
  SetLength(cNumItem,4);
  SetLength(cDTUsuario,20);
  SetLength(cSWBasico,20);
  cMFAdicional := ' ';

  for iConta := 1 to 2 do
     cTruncamento := cTruncamento + ' ';

  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
  If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
  begin
    SetLength(cNumSerie,15);
    Memo1.Lines.Add('Campo01: R05');
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    Memo1.Lines.Add('Campo03: No retornado pelo modelo de impressora');
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    Memo1.Lines.Add('Campo07: No retornado pelo modelo de impressora');
    iRetorno := Bematech_FI_UltimoItemVendido(cNumItem);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo08: ' + cNumItem);
    end;
    Memo1.Lines.Add('Campo09: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Cdigo do item.
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a descrio do item.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a quantidade do item.
    Memo1.Lines.Add('Campo12: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a unidade de medida do item.
    Memo1.Lines.Add('Campo13: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor unitrio do item.
    Memo1.Lines.Add('Campo14: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o desconto sobre o item.
    Memo1.Lines.Add('Campo15: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o acrescimo sobre o item.
    Memo1.Lines.Add('Campo16: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor lquido.
    Memo1.Lines.Add('Campo17: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o totalizador parcial.
    Memo1.Lines.Add('Campo18: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o indicador de cancelamento.
    Memo1.Lines.Add('Campo19: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a quantidade cancelada.
    Memo1.Lines.Add('Campo20: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor do cancelamento.
    Memo1.Lines.Add('Campo21: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar se esta truncando ou arredondando.
    iRetorno := Bematech_FI_VerificaTruncamento(cTruncamento);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo22: ' + cTruncamento);
    end;
    Memo1.Lines.Add('Campo23: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar se a produo  prpria ou de terceiros.
    Memo1.Lines.Add('Campo24: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar as Casas decimais enviadas para impressora.
    Memo1.Lines.Add('Campo25: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar as casas decimais enviadas para impresspra.
  end
  Else
  begin
    SetLength(cNumSerie,20);
    Memo1.Lines.Add('Campo01: R05');
    iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDTUsuario,cSWBasico,cMFAdicional);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo03: ' + cMFAdicional);
    end;
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    iRetorno := Bematech_FI_ContadorCupomFiscalMFD(cCCF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo07: ' + cCCF);
    end;
    iRetorno := Bematech_FI_UltimoItemVendido(cNumItem);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo08: ' + cNumItem);
    end;
    Memo1.Lines.Add('Campo09: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Cdigo do item.
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a descrio do item.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a quantidade do item.
    Memo1.Lines.Add('Campo12: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a unidade de medida do item.
    Memo1.Lines.Add('Campo13: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor unitrio do item.
    Memo1.Lines.Add('Campo14: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o desconto sobre o item.
    Memo1.Lines.Add('Campo15: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o acrescimo sobre o item.
    Memo1.Lines.Add('Campo16: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor lquido.
    Memo1.Lines.Add('Campo17: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o totalizador parcial.
    Memo1.Lines.Add('Campo18: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o indicador de cancelamento.
    Memo1.Lines.Add('Campo19: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar a quantidade cancelada.
    Memo1.Lines.Add('Campo20: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o valor do cancelamento.
    Memo1.Lines.Add('Campo21: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar se esta truncando ou arredondando.

    iRetorno := Bematech_FI_VerificaTruncamento(cTruncamento);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo22: ' + cTruncamento);
    end;
    Memo1.Lines.Add('Campo23: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar se a produo  prpria ou de terceiros.
    Memo1.Lines.Add('Campo24: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar as Casas decimais enviadas para impressora.
    Memo1.Lines.Add('Campo25: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar as casas decimais enviadas para impresspra.
  end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  cNumSerie: String;
  cModeloImp: String;
  cUsuario: String;
  cCOO: String;
  cGNF: String;
  cCDC: String;
  cGRG: String;
  cData: String;
  cHora: String;
  cDataHora: String;
  cDTUsuario: String;
  cSWBasico: String;
  cMFAdicional: Char;
  iRetorno: Integer;
  iACK: Integer;
  iSt1: Integer;
  iSt2: Integer;
  iSt3: Integer;
begin
  SetLength(cModeloImp,10);
  SetLength(cUsuario,4);
  SetLength(cCOO,6);
  SetLength(cCDC,4);
  SetLength(cGRG,6);
  SetLength(cGNF,6);
  SetLength(cData,6);
  SetLength(cHora,6);
  SetLength(cDataHora,12);
  SetLength(cDTUsuario,20);
  SetLength(cSWBasico,20);
  cMFAdicional := ' ';
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
  If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
  begin
    SetLength(cNumSerie,15);
    Memo1.Lines.Add('Campo01: R06');
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    Memo1.Lines.Add('Campo03: No retornado pelo modelo de impressora');
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    iRetorno := Bematech_FI_NumeroOperacoesNaoFiscais(cGNF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo07: ' + cGNF);
    end;
    Memo1.Lines.Add('Campo08: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o contador de Relatrio Gerencial.
    Memo1.Lines.Add('Campo09: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o contador de Crdito ou Dbito.
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar qual  o tipo do relatrio de acordo com as seguintes opes
    //CM - Conferncia de Mesa;        RV - Registro de venda;                     CC - Comprovante de Crdito ou Dbito;
    //CN - Comprovante No-Fiscal;     NC - Comprovante No-Fiscal Cancelamento;   RG - Relatrio Gerencial.
    iRetorno := Bematech_FI_DataHoraImpressora(cData,cHora);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo11: ' + cData);
      Memo1.Lines.Add('Campo12: ' + cHora);
    end;

  end
  Else
  begin
    SetLength(cNumSerie,20);
    Memo1.Lines.Add('Campo01: R06');
    iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDTUsuario,cSWBasico,cMFAdicional);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo03: ' + cMFAdicional);
    end;
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    iRetorno := Bematech_FI_NumeroOperacoesNaoFiscais(cGNF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo07: ' + cGNF);
    end;
    iRetorno := Bematech_FI_ContadorRelatoriosGerenciaisMFD(cGRG);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo08: ' + cGRG);
    end;
    iRetorno := Bematech_FI_NumeroOperacoesNaoFiscais(cCDC);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo09: ' + cCDC);
    end;
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar qual  o tipo do relatrio de acordo com as seguintes opes
    //CM - Conferncia de Mesa;        RV - Registro de venda;                     CC - Comprovante de Crdito ou Dbito;
    //CN - Comprovante No-Fiscal;     NC - Comprovante No-Fiscal Cancelamento;   RG - Relatrio Gerencial.
    iRetorno := Bematech_FI_DataHoraUltimoDocumentoMFD(cDataHora);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo11: ' + Copy(cDataHora,1,6));
      Memo1.Lines.Add('Campo12: ' + Copy(cDataHora,7,6));
    end;
  end;
  
end;

procedure TForm1.Button12Click(Sender: TObject);
var
  cNumSerie: String;
  cModeloImp: String;
  cUsuario: String;
  cCOO: String;
  cCCF: String;
  cGNF: String;
  cDTUsuario: String;
  cSWBasico: String;
  cMFAdicional: Char;
  iRetorno: Integer;
  iACK: Integer;
  iSt1: Integer;
  iSt2: Integer;
  iSt3: Integer;
begin
  SetLength(cModeloImp,10);
  SetLength(cUsuario,4);
  SetLength(cCOO,6);
  SetLength(cCCF,6);
  SetLength(cGNF,6);
  SetLength(cDTUsuario,20);
  SetLength(cSWBasico,20);
  cMFAdicional := ' ';
  iRetorno := Bematech_FI_ModeloImpressora(cModeloImp);
  iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
  If (Trim(cModeloImp) = 'MP20FI') or (Trim(cModeloImp) = 'MP40FI')then
  begin
    SetLength(cNumSerie,15);
    Memo1.Lines.Add('Campo01: R07');
    iRetorno := Bematech_FI_NumeroSerie(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iSt1,iSt2);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    Memo1.Lines.Add('Campo03: No retornado pelo modelo de impressora');
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressora(iACK,iST1,iST2);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    Memo1.Lines.Add('Campo07: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o contador do Cupom Fiscal.
    Memo1.Lines.Add('Campo08: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o contador de Relatrio Gerencial.
    Memo1.Lines.Add('Campo09: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Meio de Pagamento.
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Valor Pago.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Indicador de Estorno.
    Memo1.Lines.Add('Campo12: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Valor estornado.
  end
  Else
  begin
    SetLength(cNumSerie,20);
    Memo1.Lines.Add('Campo01: R07');
    iRetorno := Bematech_FI_NumeroSerieMFD(cNumSerie);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo02: ' + cNumSerie);
    end;
    iRetorno := Bematech_FI_DataHoraGravacaoUsuarioSWBasicoMFAdicional(cDTUsuario,cSWBasico,cMFAdicional);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo03: ' + cMFAdicional);
    end;
    Memo1.Lines.Add('Campo04: ' + Trim(cModeloImp));
    iRetorno := Bematech_FI_NumeroSubstituicoesProprietario(cUsuario);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo05: ' + Copy(cUsuario,3,2));
    end;
    iRetorno := Bematech_FI_NumeroCupom(cCOO);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo06: ' + cCOO);
    end;
    iRetorno := Bematech_FI_ContadorCupomFiscalMFD(cCCF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo07: ' + cCCF);
    end;
    iRetorno := Bematech_FI_NumeroOperacoesNaoFiscais(cGNF);
    If(iRetorno = 1)then
    begin
      iRetorno := Bematech_FI_RetornoImpressoraMFD(iACK,iSt1,iSt2,iSt3);
      Memo1.Lines.Add('Campo08: ' + cGNF);
    end;
    Memo1.Lines.Add('Campo09: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Meio de Pagamento.
    Memo1.Lines.Add('Campo10: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Valor Pago.
    Memo1.Lines.Add('Campo11: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Indicador de Estorno.
    Memo1.Lines.Add('Campo012: Esta Informao dever ser controlada pelo aplicativo.');
    //Esta infromao no  retornada pela impressora, o aplicativo ter que armazenar o Valor estornado.
  end;
end;

end.
